## cvc3 2.4.1

=== Makefile ===
include Makefile.local
 
# The list of Makefiles and other important script sources which must
# be included in any distribution.
DISTFILES = \
Makefile \
Makefile.std \
Makefile.local.in \
configure.ac \
configure \
config.guess \
config.sub \
install-sh \
INSTALL \
LICENSE.in \
PEOPLE \
README \
VERSION \
bin/unpack.in \
bin/run_tests.in \
bin/cvc2smt.in \
doc/Doxyfile.in \
doc/Makefile.in \
doc/devel.dox \
doc/mainpage.dox \
doc/userdoc.dox \
doc/theory_api.dox \
doc/theory_api_flow.fig \
src/Makefile \
src/cvc3.pc.in \
test/Makefile \
test/george.h \
test/george.cpp \
test/main.cpp \
testc/Makefile \
testc/main.c \
emacs/cvc-mode.el

all:	build

.PHONY: build

build: 
	cd $(TOP)/src; $(MAKE) $(TARGET) VERSION=$(VERSION)
ifeq ($(BUILD_JAVA),1)
	cd $(TOP)/java; $(MAKE) $(TARGET) VERSION=$(VERSION)
endif
ifeq ($(CYGWIN),)
ifndef TARGET
	find $(TOP)/src '(' -name "*.h" -o -name "*.cpp" -o       \
	                           -name "*.y" ')'       \
                                ! -name "lexPL.cpp" ! -name "parsePL.cpp" \
				-print  > FILES
ifdef ETAGS
	sed -e s/^/\'/ -e s/$$/\'/ FILES | xargs etags
endif
ifdef EBROWSE
	ebrowse --files=FILES
endif
endif
endif

#Standard make targets
.PHONY: depend spotty install

depend:
	$(MAKE) TARGET=depend

spotty:
	$(MAKE) TARGET=spotty

install:
	$(MAKE) TARGET=install

# Special make targets for top Makefile
.PHONY: update-web update-web-doc doc dist dist_src dist_bin ld_sh ld_csh

update-web:
	cp $(TOP)/webpage/*.html $(WEBDIR)
	cp $(TOP)/webpage/*.jpg $(WEBDIR)
	cp $(TOP)/webpage/*.css $(WEBDIR)

update-web-doc: doc
	cd $(TOP)/doc/html/; tar cvBf - . | (cd $(WEBDIR)/doc/; tar xvpBf -)

doc:
	cd $(TOP)/doc; $(MAKE)

dist: dist_src
# dist: dist_src dist_bin

TMPFILE=$(TOP)/filelist.tmp
TARDIR=cvc3-$(VERSION)
TARFILE=$(TARDIR).tar.gz
DISTTMPDIR=$(TOP)/dist-bak

dist_src:
	@mkdir -p $(DISTTMPDIR)
ifndef DPLL_BASIC
	@mv configure.ac configure $(DISTTMPDIR)
	@cat $(DISTTMPDIR)/configure.ac | sed '/#BEGIN/,/#END/ d' > $(TOP)/configure.ac
	@autoconf
endif
	@rm -rf $(TMPFILE); touch $(TMPFILE)
	echo "Collecting top-level script files"
	@echo $(DISTFILES) >> $(TMPFILE)
	cd $(TOP)/src; $(MAKE) print_src FILELIST=$(TMPFILE)
	cd $(TOP)/java; $(MAKE) print_src FILELIST=$(TMPFILE)
	echo "Building " $(TARFILE)
	@mkdir -p $(TARDIR)
	@tar cf - `cat $(TMPFILE)` | (cd $(TARDIR); tar xf -)
	@echo "$(VERSION)" > $(TARDIR)/VERSION
	@tar zcfv $(TARFILE) $(TARDIR)
ifndef DPLL_BASIC
	@rm -f configure.ac configure
	@mv $(DISTTMPDIR)/configure* $(TOP)
endif
	rm -rf $(TMPFILE) $(TARDIR) $(DISTTMPDIR)

dist_bin:
	echo "Sorry, binary distribution is not implemented yet"
	exit 1

# Generate LD_LIBRARY_PATH assignments for various shells.
# When CVC is compiled with dynamic libraries, run
#   `make ld_sh` or `make ld_tcsh`
# before running cvc executable.

ld_sh:
	@echo "export LD_LIBRARY_PATH=$(TOP)/lib"
ld_csh:
	@echo "setenv LD_LIBRARY_PATH $(TOP)/lib"

.PHONY: clean clean_gcov superclean_gcov clean_gprof distclean 

# Clean up all the files generated by gcov (including *.cpp.gcov)
clean_gcov:
	find src -name "*.da" -exec rm -f {} \;
superclean_gcov: clean_gcov
	find src -name "*.gcov" -exec rm -f {} \;
	find src -name "*.bb" -exec rm -f {} \;
	find src -name "*.bbg" -exec rm -f {} \;

clean_gprof:
	rm -f gmon.out

clean:  superclean_gcov clean_gprof
	$(MAKE) TARGET=clean
	@rm -f $(REGRESS_LOG)
	@rm -f $(TOP)/.test*

distclean:
	cd $(TOP)/src; $(MAKE) distclean
	cd $(TOP)/doc; $(MAKE) distclean
	cd $(TOP)/test; $(MAKE) distclean
	cd $(TOP)/java; $(MAKE) distclean
	rm -rf $(TOP)/test/bin $(TOP)/test/obj
	cd $(TOP)/testc; $(MAKE) distclean
	rm -rf $(TOP)/testc/bin $(TOP)/testc/obj
	@rm -rf $(DISTTMPDIR)
	@mkdir -p $(DISTTMPDIR)
	@mv $(TOP)/bin/*.in $(DISTTMPDIR)
	@-mv $(TOP)/bin/CVS $(DISTTMPDIR)
	@-mv $(TOP)/bin/.cvsignore $(DISTTMPDIR)
	rm -rf $(TOP)/bin
	@mv $(DISTTMPDIR) $(TOP)/bin
	@rm -rf $(DISTTMPDIR)
	rm -f TAGS BROWSE FILES LICENSE Makefile.local
	rm -rf $(TOP)/autom4te.cache
	rm -f config.log config.status $(LICENSE_INFO_FILE)
	rm -f $(REGRESS_LOG)
	@rm -f $(TOP)/.test*
	rm -rf $(TOP)/lib $(TOP)/obj

# Regression tests: both for internal and presentation languages.  
.PHONY: regress regress0 regress1 regress2 regress3 regress4
.PHONY: regressonly regressonly0 regressonly1 regressonly2 regressonly3 regressonly4

REGRESS_LOG=regressions.log

# The higher the level, the more tests are run (4 = all)
REGRESS_TESTS0 = benchmarks
REGRESS_TESTS1 = $(REGRESS_TESTS0)
REGRESS_TESTS2 = $(REGRESS_TESTS1)
REGRESS_TESTS3 = $(REGRESS_TESTS2)
REGRESS_TESTS4 = $(REGRESS_TESTS3)
REGRESS_TESTS = $(REGRESS_TESTS0)
REGRESS_LEVEL=0
# Program name
PROGNAME=$(TOP)/bin/cvc3
# Addiional options for run_tests script
ifndef RUN_TESTS_OPTIONS
ifeq ($(OPTIMIZED),1)
  RUN_TESTS_OPTIONS=+rt
endif
endif
# Define to max. number of seconds to run each executable.
# 0 = no limit
TIME_LIMIT=1200
# Additional options
CVC_OPTIONS=+stats
ALL_OPTIONS= -l $(REGRESS_LEVEL) -vc $(PROGNAME) $(RUN_TESTS_OPTIONS) \
             -t $(TIME_LIMIT) $(REGRESS_TESTS) -- $(CVC_OPTIONS)
regress: build
	cd $(TOP)/test; $(MAKE)
	cd $(TOP)/testc; $(MAKE)
	@echo "*********************************************************" \
          | tee -a $(REGRESS_LOG)
	@echo "Starting tests at" `date` | tee -a $(REGRESS_LOG)
	@echo "C++ API test" | tee -a $(REGRESS_LOG)
	@echo "*********************************************************" \
          | tee -a $(REGRESS_LOG)
	$(TOP)/test/bin/test $(REGRESS_LEVEL) 2>&1 \
	  | tee -a $(REGRESS_LOG); [ $${PIPESTATUS[0]} -eq 0 ]
	@echo "*********************************************************" \
          | tee -a $(REGRESS_LOG)
	@echo "C API test" | tee -a $(REGRESS_LOG)
	@echo "*********************************************************" \
          | tee -a $(REGRESS_LOG)
	$(TOP)/testc/bin/testc $(REGRESS_LEVEL)  2>&1 \
	  | tee -a $(REGRESS_LOG); [ $${PIPESTATUS[0]} -eq 0 ]
	@rm -f $(TOP)/.test*
ifeq ($(BUILD_JAVA),1)
	@echo "*********************************************************" \
          | tee -a $(REGRESS_LOG)
	@echo "Java API test" | tee -a $(REGRESS_LOG)
	@echo "*********************************************************" \
          | tee -a $(REGRESS_LOG)
	$(MAKE) -C java test 2>&1 \
	  | tee -a $(REGRESS_LOG); [ $${PIPESTATUS[0]} -eq 0 ]
endif
	@echo "*********************************************************" \
          | tee -a $(REGRESS_LOG)
	@echo "Regression tests" | tee -a $(REGRESS_LOG)
	@echo "*********************************************************" \
          | tee -a $(REGRESS_LOG)
	$(TOP)/bin/run_tests $(ALL_OPTIONS)  2>&1 \
	  | tee -a $(REGRESS_LOG); [ $${PIPESTATUS[0]} -eq 0 ]
	@echo "*********************************************************" \
          | tee -a $(REGRESS_LOG)
	@echo "Output is saved in $(REGRESS_LOG)" | tee -a $(REGRESS_LOG)
	@echo "*********************************************************" \
          | tee -a $(REGRESS_LOG)

regress0:
	$(MAKE) regress REGRESS_LEVEL=0
regress1:
	$(MAKE) regress REGRESS_LEVEL=1 REGRESS_TESTS="$(REGRESS_TESTS1)"
regress2:
	$(MAKE) regress REGRESS_LEVEL=2 REGRESS_TESTS="$(REGRESS_TESTS2)"
regress3:
	$(MAKE) regress REGRESS_LEVEL=3 REGRESS_TESTS="$(REGRESS_TESTS3)" TIME_LIMIT=1500
regress4:
	$(MAKE) regress REGRESS_LEVEL=4 REGRESS_TESTS="$(REGRESS_TESTS4)" TIME_LIMIT=0

regressonly: build
	@echo "*********************************************************" \
          | tee -a $(REGRESS_LOG)
	@echo "Starting tests at" `date` | tee -a $(REGRESS_LOG)
	@echo "*********************************************************" \
          | tee -a $(REGRESS_LOG)
	@echo "Regression tests" | tee -a $(REGRESS_LOG)
	@echo "*********************************************************" \
          | tee -a $(REGRESS_LOG)
	$(TOP)/bin/run_tests $(ALL_OPTIONS)  2>&1 \
	  | tee -a $(REGRESS_LOG); [ $${PIPESTATUS[0]} -eq 0 ]
	@echo "*********************************************************" \
          | tee -a $(REGRESS_LOG)
	@echo "Output is saved in $(REGRESS_LOG)" | tee -a $(REGRESS_LOG)
	@echo "*********************************************************" \
          | tee -a $(REGRESS_LOG)

regressonly0:
	$(MAKE) regressonly REGRESS_LEVEL=0
regressonly1:
	$(MAKE) regressonly REGRESS_LEVEL=1 REGRESS_TESTS="$(REGRESS_TESTS1)"
regressonly2:
	$(MAKE) regressonly REGRESS_LEVEL=2 REGRESS_TESTS="$(REGRESS_TESTS2)"
regressonly3:
	$(MAKE) regressonly REGRESS_LEVEL=3 REGRESS_TESTS="$(REGRESS_TESTS3)" TIME_LIMIT=1500
regressonly4:
	$(MAKE) regressonly REGRESS_LEVEL=4 REGRESS_TESTS="$(REGRESS_TESTS4)" TIME_LIMIT=0

=== java/Makefile ===
# Makefile for creating the java wrapper around the cvc library
# as well as a java command line client

include ../Makefile.local

### Variables

# package name
PACKAGE = cvc3

# directories
# source files: java, cpp
SOURCE_PATH = src
# header files: h
HEADER_PATH = include
# object files: class, o
OBJ_PATH    = obj
# library files: so, jar
REL_LIB_PATH  = java/lib
LIB_PATH      = $(TOP)/$(REL_LIB_PATH)
REL_ARCH_LIB_PATH = $(REL_LIB_PATH)/$(PLATFORM_WITH_OPTIONS)
ARCH_LIB_PATH = $(TOP)/$(REL_ARCH_LIB_PATH)

CPPFLAGS += $(JAVA_INCLUDES)

ifneq ($(CYGWIN),)
CPPFLAGS += '-D__int64=long long'
endif

ifeq ($(OPTIMIZED), 1)
CXXFLAGS += -O2
else
CXXFLAGS += -D_CVC3_DEBUG_MODE -g -O0
endif


# Java compiler flags
# - source 1.4 is needed for Escjava
# - Xlint may be compiler dependent
JFLAGS += -Xlint -g -source 1.4

# source files
# java files of the library wrapper
LIB_FILES = \
	JniUtils \
	Cvc3Exception TypecheckException SoundException EvalException \
	CLException ParserException SmtlibException DebugException \
	Embedded EmbeddedManager \
	InputLanguage QueryResult SatResult FormulaValue \
	Expr ExprMut ExprManager ExprManagerMut \
	Type TypeMut Op OpMut Rational RationalMut \
	Theorem TheoremMut Proof ProofMut Context ContextMut \
	Flag Flags FlagsMut \
	Statistics StatisticsMut ValidityChecker
# java files of the test program
TEST_FILES = Test
# java files of the stand alone program
PROG_FILES = TimeoutHandler Cvc3
# all java files, library and stand alone
JAVA_FILES = $(LIB_FILES) $(TEST_FILES) $(PROG_FILES)
# jni files of the library wrapper
JNI_FILES = \
	EmbeddedManager \
	Expr ExprMut ExprManager \
	Type TypeMut Op OpMut Rational RationalMut \
	Theorem TheoremMut Proof ProofMut Context ContextMut \
	Flag Flags FlagsMut \
	Statistics StatisticsMut ValidityChecker
# stub files
IMPL_FILES = $(addsuffix _impl.cpp,$(JNI_FILES))
# generated files
JNI_CPP_FILES = $(patsubst %,%.cpp,$(JNI_FILES))
# non-generated files
SRC_CPP_FILES = JniUtils.cpp 
# all cpp files (to compile)
CPP_FILES = $(SRC_CPP_FILES) $(JNI_CPP_FILES)

HEADER_FILES = JniUtils.h
PYTHON_FILES = run_all.py run_tests.py create_impl.py
MANIFEST_FILES = Cvc3_manifest Test_manifest

DIST_FILES = \
Makefile \
README \
$(addprefix $(SOURCE_PATH)/$(PACKAGE)/, \
  $(addsuffix .java, $(JAVA_FILES)) \
  $(IMPL_FILES) $(SRC_CPP_FILES)) \
$(addprefix $(HEADER_PATH)/$(PACKAGE)/, $(HEADER_FILES)) \
$(PYTHON_FILES) \
$(MANIFEST_FILES)


# target files
# java library files compiled to class files 
LIB_CLASS_FILES = $(patsubst %,%.class,$(LIB_FILES))
# test files compiled to class files 
TEST_CLASS_FILES = $(patsubst %,%.class,$(TEST_FILES))
# cvc3 standalone files compiled to class files 
PROG_CLASS_FILES = $(patsubst %,%.class,$(PROG_FILES))
# all compiled java files, library and stand alone
CLASS_FILES = $(LIB_CLASS_FILES) $(TEST_CLASS_FILES) $(PROG_CLASS_FILES)
# jni header files created from the library class files
H_FILES = $(patsubst %,%.h,$(JNI_FILES))
# precompiled header files
GCH_FILES = $(patsubst %.h,%.h.gch,$(H_FILES)) JniUtils.h.gch
# cpp files compiled to object files
JNI_O_FILES = $(patsubst %.cpp,%.o,$(JNI_CPP_FILES))
O_FILES = $(patsubst %.cpp,%.o,$(CPP_FILES))

# library files
# cpp library
LIB_PREFIX = lib
LIB_JNI_NAME = $(LIB_PREFIX)cvc3jni
ifneq ($(CYGWIN),)
  LIB_JNI_BASE   = $(LIB_JNI_NAME).$(SHARED_LIB_SUFFIX)
  LIB_JNI   = $(LIB_JNI_NAME)-$(subst .,-,$(LIB_VERSION)).$(SHARED_LIB_SUFFIX)
  LIB_JNI_COMPAT  = $(LIB_JNI_NAME)-$(subst .,-,$(LIB_COMPAT_VERSION)).$(SHARED_LIB_SUFFIX)
  LIB_JNI_MAJOR  = $(LIB_JNI_NAME)-$(subst .,-,$(LIB_MAJOR_VERSION)).$(SHARED_LIB_SUFFIX)
else
LIB_JNI_BASE   = $(LIB_JNI_NAME).$(SHARED_LIB_SUFFIX)
ifneq ($(MAC_OSX),)
  LIB_JNI   = $(LIB_JNI_NAME).$(LIB_VERSION).$(SHARED_LIB_SUFFIX)
  LIB_JNI_COMPAT  = $(LIB_JNI_NAME).$(LIB_COMPAT_VERSION).$(SHARED_LIB_SUFFIX)
  LIB_JNI_MAJOR  = $(LIB_JNI_NAME).$(LIB_MAJOR_VERSION).$(SHARED_LIB_SUFFIX)
else
  LIB_JNI   = $(LIB_JNI_BASE).$(LIB_VERSION)
  LIB_JNI_COMPAT  = $(LIB_JNI_BASE).$(LIB_COMPAT_VERSION)
  LIB_JNI_MAJOR  = $(LIB_JNI_BASE).$(LIB_MAJOR_VERSION)
endif
endif
# java library
LIB_CVC3  = libcvc3-$(LIB_VERSION).jar
# test alone
PROG_TEST = cvc3test.jar
# java stand alone
PROG_CVC3 = cvc3.jar


### virtual file lookup paths
#VPATH = src/cvc3/
vpath %.java  $(SOURCE_PATH)/$(PACKAGE)
vpath %.cpp   $(SOURCE_PATH)/$(PACKAGE)
vpath %.h     $(HEADER_PATH)/$(PACKAGE)
vpath %.h.gch $(HEADER_PATH)/$(PACKAGE)
vpath %.class $(OBJ_PATH)/$(PACKAGE)
vpath %.o     $(OBJ_PATH)/$(PACKAGE)


.PHONY: all classes headers objects libs libjni libcvc3 testlib cvc3 test regress print_src clean distclean %.d

### rules

all: classes headers objects libs
libs: libjni libcvc3 testlib cvc3

%.d:
	if [ ! -d $* ]; then mkdir -p $*; fi

$(OBJ_PATH): $(OBJ_PATH).d
$(LIB_PATH): $(LIB_PATH).d
$(ARCH_LIB_PATH): $(ARCH_LIB_PATH).d

# compile each java file
classes: $(OBJ_PATH) $(CLASS_FILES) 
$(CLASS_FILES): %.class: %.java $(OBJ_PATH)
	$(JAVAC) $(JFLAGS) -sourcepath $(SOURCE_PATH) \
	-d $(OBJ_PATH) $(SOURCE_PATH)/$(PACKAGE)/$*.java

# create a jni header file for each library class file
#headers: $(H_FILES) $(GCH_FILES)
headers: $(OBJ_PATH) $(H_FILES)
$(H_FILES): %.h: %.class $(OBJ_PATH)
	$(JAVAH) -jni -force -classpath $(OBJ_PATH) \
	-o $(HEADER_PATH)/$(PACKAGE)/$*.h $(PACKAGE).$*

# precompile headers
$(GCH_FILES): %.h.gch: %.h
	$(CXX) $(CPPFLAGS) $(CXXFLAGS) \
	-I ../src/include -I $(HEADER_PATH)/$(PACKAGE)/ \
	-o $(HEADER_PATH)/$(PACKAGE)/$*.h.gch $(HEADER_PATH)/$(PACKAGE)/$*.h

# compile each cpp file
$(JNI_CPP_FILES): %.cpp: %_impl.cpp %.h JniUtils.h
	$(PYTHON) ./create_impl.py \
	$(HEADER_PATH)/$(PACKAGE)/$*.h \
	$(SOURCE_PATH)/$(PACKAGE)/$*_impl.cpp \
	$(SOURCE_PATH)/$(PACKAGE)/$*.cpp

objects: $(OBJ_PATH) $(O_FILES) 
$(O_FILES): %.o: %.cpp %.h $(OBJ_PATH)
	$(CXX) $(CPPFLAGS) $(CXXFLAGS) -c \
	-I ../src/include -I $(HEADER_PATH)/$(PACKAGE)/ \
	-o $(OBJ_PATH)/$(PACKAGE)/$*.o $(SOURCE_PATH)/$(PACKAGE)/$*.cpp

# create the cpp jni wrapper library

libjni: $(ARCH_LIB_PATH)/$(LIB_JNI) $(LIB_PATH)/$(LIB_JNI)
$(ARCH_LIB_PATH)/$(LIB_JNI): $(O_FILES) $(ARCH_LIB_PATH)
ifneq ($(MAC_OSX),)
	$(CXX) $(SHARED) $(CXXFLAGS) $(LDFLAGS) \
      -install_name $(libdir)/$(LIB_JNI_MAJOR) \
      -compatibility_version $(LIB_COMPAT_VERSION) \
      -current_version $(LIB_VERSION) \
      -L../lib $(OBJ_PATH)/$(PACKAGE)/*.o \
      -o '$(ARCH_LIB_PATH)/$(LIB_JNI)' `` -lcvc3 $(LD_LIBS)
else
	$(CXX) $(SHARED) $(CXXFLAGS) $(LDFLAGS) \
      -Wl,-soname,$(LIB_JNI_COMPAT) \
      -L ../lib $(OBJ_PATH)/$(PACKAGE)/*.o \
      -o $(ARCH_LIB_PATH)/$(LIB_JNI) -lcvc3 $(LD_LIBS)
ifeq ($(CYGWIN),)
	$(LDCONFIG) -nv $(ARCH_LIB_PATH)
endif
endif
	ln -sf $(LIB_JNI) $(ARCH_LIB_PATH)/$(LIB_JNI_COMPAT)
	ln -sf $(LIB_JNI) $(ARCH_LIB_PATH)/$(LIB_JNI_MAJOR)
	ln -sf $(LIB_JNI) $(ARCH_LIB_PATH)/$(LIB_JNI_BASE)

#	$(CXX) $(CPPFLAGS) $(CXXFLAGS) -shared \

#$(LIB_PATH)/$(LIB_JNI): $(O_FILES)
#	ar ruvs $(LIB_PATH)/libcvc3jni.a $(OBJ_PATH)/$(PACKAGE)/*.o
#	$(CXX) $(CXXFLAGS) -shared -Wl,-soname,$(LIB_JNI) \
#	-L ../lib -lc -lcvc3 -lgmp \
#	$(LIB_PATH)/libcvc3jni.a \
#	-o $(LIB_PATH)/$(LIB_JNI)

#ar ruvs /media/data/ESCJava/CVC3/cvc3/lib/linux-i686-debug/libvcl.a  /media/data/ESCJava/CVC3/cvc3/obj/vcl/linux-i686-debug/vcl.o  /media/data/ESCJava/CVC3/cvc3/obj/vcl/linux-i686-debug/vc_cmd.o

$(LIB_PATH)/$(LIB_JNI): $(ARCH_LIB_PATH)/$(LIB_JNI)
	ln -sf $< $@
# [chris] ldconfig seems to just delete the .so's!
# $(LDCONFIG) -nv '$(call dirx,$@)'
	ln -sf $(LIB_JNI) '$(call dirx,$@)/$(LIB_JNI_COMPAT)'
	ln -sf $(LIB_JNI) '$(call dirx,$@)/$(LIB_JNI_MAJOR)'
	ln -sf $(LIB_JNI) '$(call dirx,$@)/$(LIB_JNI_BASE)'

# create the java wrapper library
libcvc3: $(LIB_PATH) $(LIB_PATH)/$(LIB_CVC3)
$(LIB_PATH)/$(LIB_CVC3): $(LIB_CLASS_FILES)
	cd $(OBJ_PATH) && $(JAR) cf ../../$(REL_LIB_PATH)/$(LIB_CVC3) $(PACKAGE)/*.class


install: $(ARCH_LIB_PATH)/$(LIB_JNI) $(LIB_PATH)/$(LIB_CVC3)
	mkdir -p $(javadir)
	$(INSTALL) $(INSTALL_FLAGS) -m 644 $(LIB_PATH)/$(LIB_CVC3) $(javadir)
	mkdir -p $(libdir)
	$(INSTALL) $(INSTALL_FLAGS) -m 644 $(ARCH_LIB_PATH)/$(LIB_JNI) $(libdir)
	ln -sf $(LIB_JNI) $(libdir)/$(LIB_JNI_MAJOR)
	ln -sf $(LIB_JNI) $(libdir)/$(LIB_JNI_COMPAT)
	ln -sf $(LIB_JNI) $(libdir)/$(LIB_JNI_BASE)
ifeq ($(MAC_OSX),)
ifeq ($(CYGWIN),)
	$(LDCONFIG) -nv $(libdir)
endif
endif
#	chmod 644 $(libdir)/$(LIB_JNI)


# create the java stand alone program
cvc3: $(LIB_PATH) $(LIB_PATH)/$(PROG_CVC3)
$(LIB_PATH)/$(PROG_CVC3): $(PROG_CLASS_FILES)
	$(JAR) -cmf Cvc3_manifest ../$(REL_LIB_PATH)/$(PROG_CVC3)
	@for i in $(PROG_CLASS_FILES); do \
	  echo $(JAR) -uf ../$(REL_LIB_PATH)/$(PROG_CVC3) -C $(OBJ_PATH) $(PACKAGE)/$$i; \
	  $(JAR) -uf ../$(REL_LIB_PATH)/$(PROG_CVC3) -C $(OBJ_PATH) $(PACKAGE)/$$i; \
	done

# create the test stand alone program
testlib: $(LIB_PATH) $(LIB_PATH)/$(PROG_TEST)

test: testlib
	$(JAVA) $(JREFLAGS) -Djava.library.path=../$(REL_ARCH_LIB_PATH) -ea -jar ../$(REL_LIB_PATH)/$(PROG_TEST)

$(LIB_PATH)/$(PROG_TEST): $(TEST_CLASS_FILES)
	echo -e "Main-Class: cvc3/Test\nClass-Path: $(LIB_CVC3)\n" > Test_manifest
	$(JAR) -cmf Test_manifest ../$(REL_LIB_PATH)/$(PROG_TEST)
	@for i in $(TEST_CLASS_FILES); do \
	  echo $(JAR) -uf ../$(REL_LIB_PATH)/$(PROG_TEST) -C $(OBJ_PATH) $(PACKAGE)/$$i; \
	  $(JAR) -uf ../$(REL_LIB_PATH)/$(PROG_TEST) -C $(OBJ_PATH) $(PACKAGE)/$$i; \
	done

regress: cvc3
	$(PYTHON) ./run_tests.py \
	-vc '$(JAVA) $(JREFLAGS) -Djava.library.path=../$(REL_LIB_PATH) -ea -Xss100M -jar ../$(REL_LIB_PATH)/$(PROG_CVC3)' \
	-t 15 -m 500 -l 4 ../benchmarks


ifndef FILELIST
FILELIST = /dev/null
endif

print_src:
	echo $(addprefix java/, $(DIST_FILES)) >> $(FILELIST)
#	echo $(patsubst %, src/include/%, $(HEADER_NAMES)) >> $(FILELIST)



# clean up

clean: $(OBJ_PATH)
	rm -f $(addprefix $(SOURCE_PATH)/$(PACKAGE)/, $(JNI_CPP_FILES))
	rm -fr $(OBJ_PATH)/$(PACKAGE)/*
	rm -fr $(LIB_PATH)/*
	rm -f $(addprefix $(HEADER_PATH)/$(PACKAGE)/, $(H_FILES) $(GCH_FILES))

distclean: clean

=== src/Makefile ===
include ../Makefile.local

###########################################################
#### Developers: add new API files to HEADER_NAMES ########
###########################################################

# Header files that define the exposed API
HEADER_NAMES = \
  assumptions.h \
  c_interface.h \
  c_interface_defs.h \
  cdflags.h \
  cdlist.h \
  cdmap.h \
  cdmap_ordered.h \
  cdo.h \
  circuit.h \
  clause.h \
  cnf.h \
  cnf_manager.h \
  command_line_exception.h \
  command_line_flags.h \
  common_proof_rules.h \
  compat_hash_map.h \
  compat_hash_set.h \
  context.h \
  cvc_util.h \
  debug.h \
  dpllt.h \
  dpllt_basic.h \
  dpllt_minisat.h \
  eval_exception.h \
  exception.h \
  expr.h \
  expr_hash.h \
  expr_manager.h \
  expr_map.h \
  expr_op.h \
  expr_stream.h \
  expr_transform.h \
  expr_value.h \
  formula_value.h \
  fdstream.h \
  hash_fun.h \
  hash_table.h \
  hash_map.h \
  hash_set.h \
  kinds.h \
  lang.h \
  memory_manager.h \
  memory_manager_chunks.h \
  memory_manager_malloc.h \
  memory_manager_context.h \
  notifylist.h \
  os.h \
  parser.h \
  proof.h \
  rational.h \
  parser_exception.h \
  pretty_printer.h \
  queryresult.h \
  sat_api.h \
  search.h \
  search_impl_base.h \
  search_sat.h \
  search_simple.h \
  search_fast.h \
  smartcdo.h \
  smtlib_exception.h \
  sound_exception.h \
  statistics.h \
  theorem.h \
  theorem_manager.h \
  theorem_producer.h \
  theory_arith.h \
  theory_arith_new.h \
  theory_arith_old.h \
  theory_arith3.h \
  theory_array.h \
  theory_bitvector.h \
  theory_core.h \
  theory_datatype.h \
  theory_datatype_lazy.h \
  theory.h \
  theory_quant.h \
  theory_records.h \
  theory_simulate.h \
  theory_uf.h \
  translator.h \
  typecheck_exception.h \
  type.h \
  variable.h \
  vc_cmd.h \
  vc.h \
  vcl.h

MODULES = cvc_util \
	context \
	expr \
	theorem \
	sat \
	theory_core \
	theory_arith \
	theory_array \
	theory_bitvector \
	theory_datatype \
	theory_quant \
	theory_records \
	theory_simulate \
	theory_uf \
	search \
	parser \
	translator \
	vcl \
	c_interface

CVC_EXE = $(TOP)/bin/$(PROJECTNAME)
LIB_BASE=$(LIB_DIR)/$(LIB_BASE_NAME)
LIB_STATIC_NAME=$(LIB_BASE_NAME).$(STATIC_LIB_SUFFIX)
LIB_SHARED_BASE=$(LIB_BASE_NAME).$(SHARED_LIB_SUFFIX)
ifneq ($(CYGWIN),)
    LIB_SHARED_MAJOR=$(LIB_BASE_NAME)-$(subst .,-,$(LIB_MAJOR_VERSION)).$(SHARED_LIB_SUFFIX)
    LIB_SHARED_COMPAT=$(LIB_BASE_NAME)-$(subst .,-,$(LIB_COMPAT_VERSION)).$(SHARED_LIB_SUFFIX)
    LIB_SHARED_FULL=$(LIB_BASE_NAME)-$(subst .,-,$(LIB_VERSION)).$(SHARED_LIB_SUFFIX)
else
ifneq ($(MAC_OSX),)
    LIB_SHARED_MAJOR=$(LIB_BASE_NAME).$(LIB_MAJOR_VERSION).$(SHARED_LIB_SUFFIX)
    LIB_SHARED_COMPAT=$(LIB_BASE_NAME).$(LIB_COMPAT_VERSION).$(SHARED_LIB_SUFFIX)
    LIB_SHARED_FULL=$(LIB_BASE_NAME).$(LIB_VERSION).$(SHARED_LIB_SUFFIX)
else
    LIB_SHARED_MAJOR=$(LIB_SHARED_BASE).$(LIB_MAJOR_VERSION)
    LIB_SHARED_COMPAT=$(LIB_SHARED_BASE).$(LIB_COMPAT_VERSION)
    LIB_SHARED_FULL=$(LIB_SHARED_BASE).$(LIB_VERSION)
endif
endif
# LIB_SONAME=$(LIB_SHARED_FULL).$(SONAME)
LIB_STATIC=$(LIB_DIR)/$(LIB_STATIC_NAME)
LIB_SHARED=$(LIB_DIR)/$(LIB_SHARED_FULL)
LIBS = $(patsubst %, $(LIB_DIR)/lib%.$(STATIC_LIB_SUFFIX), $(MODULES))
ifeq ($(STATIC),1)
  LIB_TO_BUILD = $(LIB_STATIC)
else
  LIB_TO_BUILD = $(LIB_SHARED)
endif
# Using notdirx, in case path has spaces
CVC_LIB_NAME = $(call notdirx, $(LIB_TO_BUILD))
CVC_LIB_DIR = $(TOP)/lib
CVC_LIB = $(CVC_LIB_DIR)/$(CVC_LIB_NAME)

.PHONY: all build depend clean spotty install print_src distclean

all: build

# List all module subdirs here
build:
	cd util && $(MAKE) $(TARGET)
	cd context && $(MAKE) $(TARGET)
	cd expr && $(MAKE) $(TARGET)
	cd theorem && $(MAKE) $(TARGET)
	cd sat && $(MAKE) $(TARGET)
	cd theory_core && $(MAKE) $(TARGET)
	cd theory_arith && $(MAKE) $(TARGET)
	cd theory_array && $(MAKE) $(TARGET)
	cd theory_bitvector && $(MAKE) $(TARGET)
	cd theory_datatype && $(MAKE) $(TARGET)
	cd theory_quant && $(MAKE) $(TARGET)
	cd theory_records && $(MAKE) $(TARGET)
	cd theory_simulate && $(MAKE) $(TARGET)
	cd theory_uf && $(MAKE) $(TARGET)
	cd search && $(MAKE) $(TARGET)
	cd parser && $(MAKE) $(TARGET)
	cd translator && $(MAKE) $(TARGET)
	cd vcl && $(MAKE) $(TARGET)
	cd c_interface && $(MAKE) $(TARGET)
ifndef TARGET
	@rm -rf $(CVC_LIB)
	$(MAKE) $(CVC_LIB)
endif
	cd cvc3 && $(MAKE) $(TARGET) VERSION=$(VERSION)

# No need to change anything below this point when adding headers/modules

UNPACKTMPDIR=$(TOP)/unpack_tmp


$(LIB_STATIC): $(LIBS)
	-rm -rf $(UNPACKTMPDIR)
	$(TOP)/bin/unpack $(UNPACKTMPDIR) $(LIBS) > UNPACKED
	cat UNPACKED | xargs $(AR) ruvs '$@.$(LIB_VERSION)'
	rm -rf $(UNPACKTMPDIR) UNPACKED
	@echo Linking $(LIB_STATIC_NAME) to $@
	ln -sf $(LIB_STATIC_NAME).$(LIB_VERSION) '$@'

$(LIB_SHARED): $(LIBS)
	@echo Building shared library $(LIB_SHARED)
	-rm -rf $(UNPACKTMPDIR)
	$(TOP)/bin/unpack $(UNPACKTMPDIR) $(LIBS) > UNPACKED
ifneq ($(MAC_OSX),)
	cat UNPACKED | xargs $(CXX) $(SHARED) $(CXXFLAGS) $(LDFLAGS) \
    -install_name $(libdir)/$(LIB_SHARED_MAJOR) \
    -compatibility_version $(LIB_COMPAT_VERSION) \
    -current_version $(LIB_VERSION) \
    -o '$(LIB_SHARED)' `` $(LD_LIBS)
else
ifneq ($(CYGWIN),)
	eval $(CXX) $(SHARED) $(CXXFLAGS) $(LDFLAGS) \
    -Wl,-soname,$(LIB_SHARED_MAJOR) -o \''$(LIB_SHARED)'\' `cat UNPACKED` $(LD_LIBS)
else
	cat UNPACKED | xargs $(CXX) $(SHARED) $(CXXFLAGS) $(LDFLAGS) \
    -Wl,-soname,$(LIB_SHARED_MAJOR) -o '$(LIB_SHARED)' `` $(LD_LIBS)
	$(LDCONFIG) -nv $(LIB_DIR)
endif
endif
	ln -sf $(LIB_SHARED_FULL) $(LIB_DIR)/$(LIB_SHARED_COMPAT)
	ln -sf $(LIB_SHARED_FULL) $(LIB_DIR)/$(LIB_SHARED_MAJOR)
	ln -sf $(LIB_SHARED_FULL) $(LIB_DIR)/$(LIB_SHARED_BASE)
	@rm -rf $(UNPACKTMPDIR) UNPACKED

ifeq ($(STATIC),1)
$(CVC_LIB): $(LIB_STATIC)
	ln -sf $(LIB_STATIC).$(LIB_VERSION) '$(call dirx,$@)/$(LIB_STATIC_NAME).$(LIB_VERSION)'
	ln -sf $(LIB_STATIC_NAME).$(LIB_VERSION) '$@'
else
$(CVC_LIB): $(LIB_SHARED)
	ln -sf $(LIB_SHARED) '$(call dirx,$@)/$(LIB_SHARED_FULL)'
ifeq ($(MAC_OSX),)
ifeq ($(CYGWIN),)
	$(LDCONFIG) -nv '$(call dirx,$@)'
endif
endif
	ln -sf $(LIB_SHARED_FULL) '$(call dirx,$@)/$(LIB_SHARED_COMPAT)'
	ln -sf $(LIB_SHARED_FULL) '$(call dirx,$@)/$(LIB_SHARED_MAJOR)'
	ln -sf $(LIB_SHARED_FULL) '$(call dirx,$@)/$(LIB_SHARED_BASE)'
endif

# Standard make targets

depend:
	$(MAKE) build TARGET=depend

clean:
	$(MAKE) build TARGET=clean
	rm -f $(LIB_STATIC)* $(LIB_SHARED)* $(CVC_LIB)

distclean:
	$(MAKE) build TARGET=distclean
	rm -rf cvc3.pc

spotty:
	$(MAKE) build TARGET=spotty
	rm -f $(LIB_STATIC) $(LIB_SHARED) $(CVC_LIB)

HEADERS = $(patsubst %, $(TOP)/src/include/%, $(HEADER_NAMES))

install: $(HEADERS)
	$(MAKE) build TARGET=
	mkdir -p $(incdir)
	$(INSTALL) $(INSTALL_FLAGS) -m 644 $(HEADERS) $(incdir)
	mkdir -p $(libdir)
ifeq ($(STATIC),1)
	$(INSTALL) $(INSTALL_FLAGS) -m 644 $(CVC_LIB_DIR)/$(CVC_LIB_NAME).$(LIB_VERSION) $(libdir)
	ln -sf $(CVC_LIB_NAME).$(LIB_VERSION) $(libdir)/$(call notdirx,$(CVC_LIB))
else
	$(INSTALL) $(INSTALL_FLAGS) -m 644 $(CVC_LIB) $(libdir)
ifeq ($(MAC_OSX),)
ifeq ($(CYGWIN),)
	$(LDCONFIG) -nv $(libdir)
endif
endif
	ln -sf $(CVC_LIB_NAME) $(libdir)/$(LIB_SHARED_COMPAT) 
	ln -sf $(CVC_LIB_NAME) $(libdir)/$(LIB_SHARED_MAJOR)
	ln -sf $(CVC_LIB_NAME) $(libdir)/$(LIB_SHARED_BASE)
endif
	mkdir -p $(bindir)
	$(INSTALL) $(INSTALL_FLAGS) -m 755 $(CVC_EXE) $(bindir)
	mkdir -p $(libdir)/pkgconfig
	$(INSTALL) $(INSTALL_FLAGS) -m 644 cvc3.pc $(libdir)/pkgconfig

ifndef FILELIST
FILELIST = /dev/null
endif

print_src:
	$(MAKE) build TARGET=print_src
	echo $(patsubst %, src/include/%, $(HEADER_NAMES)) >> $(FILELIST)

=== test/Makefile ===
##################################################
# About this Makefile
#
# This Makefile depends on srcMakefile.opts
##################################################

EXECUTABLE=test

SRC = main.cpp george.cpp

HEADERS = george.h

#On some compilers, george.cpp takes forever with -O2
EXTRAFLAGS = -O0

LD_LIBS = -l$(PROJECTNAME)

OTHER_DEPENDENCIES = $(TOP)/lib/lib$(PROJECTNAME).$(LIB_SUFFIX)

BASE_DIR = $(TOP)/test

include ../Makefile.local

=== testc/Makefile ===
##################################################
# About this Makefile
#
# This Makefile depends on srcMakefile.opts
##################################################

EXECUTABLE = testc

LD_LIBS = -l$(PROJECTNAME)

BASE_DIR = $(TOP)/testc

OTHER_OBJ = $(OBJ_DIR)/main.o
OTHER_DEPENDENCIES = $(TOP)/lib/lib$(PROJECTNAME).$(LIB_SUFFIX)
MY_DEPEND = 1

TRANSIENT = $(OBJ_DIR)/main.o

include ../Makefile.local

$(OBJ_DIR)/main.o : main.c
	@mkdir -p $(OBJ_DIR)
	gcc $(CXXFLAGS) -g -I../src/include -o $(OBJ_DIR)/main.o -c main.c

depend: main.c
	@mkdir -p $(OBJ_DIR)
	@-rm -f $(MAKEFILE_DEPS) $(MAKEFILE_DEPS_TMP) $(MAKEFILE_DEPS_TMP2)
	@echo '# Dependencies for C files' >> $(MAKEFILE_DEPS_TMP)
	@echo >> $(MAKEFILE_DEPS_TMP)
	@echo "Making dependencies for $(SRC)"
	gcc -M -g -I../src/include main.c >> $(MAKEFILE_DEPS_TMP)
	@echo >> $(MAKEFILE_DEPS_TMP)
	@sed -e '/^.*:/ s#^#$(OBJ_DIR)/#' < $(MAKEFILE_DEPS_TMP) > $(MAKEFILE_DEPS_TMP2)
	@cat $(MAKEFILE_DEPS_TMP2) > $(MAKEFILE_DEPS)
	@rm -f $(MAKEFILE_DEPS_TMP) $(MAKEFILE_DEPS_TMP2)

=== src/c_interface/Makefile ===
##################################################
# About this Makefile
#
# This Makefile depends on Makefile.opts
##################################################

MODULE = c_interface

SRC = c_interface.cpp

LIBRARY=libc_interface.a

include ../../Makefile.local

=== src/context/Makefile ===
##################################################
# About this Makefile
#
# This Makefile depends on Makefile.opts
##################################################

MODULE = context

SRC = context.cpp cdflags.cpp

LIBRARY=libcontext.a

include ../../Makefile.local

=== src/cvc3/Makefile ===
##################################################
# About this Makefile
#
# This Makefile depends on Makefile.opts
##################################################

MODULE = cvc3

SRC =   main.cpp

EXECUTABLE = $(PROJECTNAME)

EXTRAFLAGS = -DVERSION=\"$(VERSION)\"

LD_LIBS = -l$(PROJECTNAME)

OTHER_DEPENDENCIES = $(TOP)/lib/$(PLATFORM_WITH_OPTIONS)/$(LIB_BASE_NAME).$(LIB_SUFFIX)

include ../../Makefile.local

=== src/expr/Makefile ===
##################################################
# About this Makefile
#
# This Makefile depends on Makefile.opts
##################################################

MODULE = expr

SRC =   expr.cpp \
  expr_manager.cpp \
  expr_stream.cpp \
  expr_value.cpp \
  expr_op.cpp

LIBRARY=libexpr.a

include ../../Makefile.local

=== src/parser/Makefile ===
MODULE = parser

LIBRARY=libparser.a

# Do not optimize the parser code - it compiles forever in some gcc versions
EXTRAFLAGS = -O0

TRANSIENT_CPP = \
 parsePL.cpp lexPL.cpp \
 parseLisp.cpp lexLisp.cpp \
 parsesmtlib.cpp lexsmtlib.cpp \
 parsesmtlib2.cpp lexsmtlib2.cpp

TRANSIENT = $(TRANSIENT_CPP) \
  parsePL_defs.h parsePL.output \
  parseLisp_defs.h parseLisp.output \
  parsesmtlib_defs.h parsesmtlib.output \
  parsesmtlib2_defs.h parsesmtlib2.output

SRC = $(TRANSIENT_CPP) parser.cpp

HEADERS = parser_temp.h

# The actual source files for the parser that we want to include in a
# distribution
SRC_ORIG = PL.lex PL.y Lisp.lex Lisp.y smtlib.lex smtlib.y smtlib2.lex smtlib2.y parser.cpp

include ../../Makefile.local

##################################################
# Rules for transient files
##################################################
lexPL.cpp:      PL.lex parsePL_defs.h
		$(LEX) $(LFLAGS) -I -PPL -olexPL.cpp PL.lex

parsePL_defs.h: parsePL.cpp

parsePL.cpp:    PL.y
		$(YACC) $(YFLAGS) -o parsePL.cpp -p PL --debug -v PL.y
		@if [ -f parsePL.cpp.h ]; then mv parsePL.cpp.h parsePL.hpp; fi
		@mv parsePL.hpp parsePL_defs.h

lexLisp.cpp:    Lisp.lex parseLisp_defs.h
		$(LEX) $(LFLAGS) -I -PLisp -olexLisp.cpp Lisp.lex

parseLisp_defs.h: parseLisp.cpp

parseLisp.cpp:  Lisp.y
		$(YACC) $(YFLAGS) -o parseLisp.cpp -p Lisp --debug -v Lisp.y
		@if [ -f parseLisp.cpp.h ]; then mv parseLisp.cpp.h parseLisp.hpp; fi
		@mv parseLisp.hpp parseLisp_defs.h

lexsmtlib.cpp:  smtlib.lex parsesmtlib_defs.h
		$(LEX) $(LFLAGS) -I -Psmtlib -olexsmtlib.cpp smtlib.lex

parsesmtlib_defs.h: parsesmtlib.cpp

parsesmtlib.cpp: smtlib.y
		$(YACC) $(YFLAGS) -o parsesmtlib.cpp -p smtlib --debug -v smtlib.y
		@if [ -f parsesmtlib.cpp.h ]; then mv parsesmtlib.cpp.h parsesmtlib.hpp; fi
		@mv parsesmtlib.hpp parsesmtlib_defs.h

lexsmtlib2.cpp:  smtlib2.lex parsesmtlib2_defs.h
		$(LEX) $(LFLAGS) -I -Psmtlib2 -olexsmtlib2.cpp smtlib2.lex

parsesmtlib2_defs.h: parsesmtlib2.cpp

parsesmtlib2.cpp: smtlib2.y
		$(YACC) $(YFLAGS) -o parsesmtlib2.cpp -p smtlib2 --debug -v smtlib2.y
		@if [ -f parsesmtlib2.cpp.h ]; then mv parsesmtlib2.cpp.h parsesmtlib2.hpp; fi
		@mv parsesmtlib2.hpp parsesmtlib2_defs.h

=== src/sat/Makefile ===
##################################################
# About this Makefile
#
# This Makefile depends on Makefile.opts
##################################################

MODULE = sat

SRC = $(EXTRA_SAT_CPP) \
      cnf.cpp \
      cnf_manager.cpp \
      cnf_theorem_producer.cpp \
      dpllt_basic.cpp \
      sat_api.cpp \
      dpllt_minisat.cpp \
      minisat_types.cpp \
      minisat_derivation.cpp \
      minisat_solver.cpp


HEADERS = $(EXTRA_SAT_HEADERS) \
          cnf_rules.h \
          cnf_theorem_producer.h \
	  sat_proof.h \
          minisat_global.h \
          minisat_heap.h \
          minisat_types.h \
          minisat_varorder.h \
          minisat_derivation.h \
          minisat_solver.h

LIBRARY=libsat.a

EXTRAFLAGS=$(DPLL_BASIC)

include ../../Makefile.local

=== src/search/Makefile ===
##################################################
# About this Makefile
#
# This Makefile depends on Makefile.opts
##################################################

MODULE = search

SRC = \
 clause.cpp \
 search_impl_base.cpp \
 search.cpp \
 search_fast.cpp \
 search_theorem_producer.cpp \
 search_sat.cpp \
 search_simple.cpp \
 variable.cpp \
 circuit.cpp \
 decision_engine.cpp \
 decision_engine_dfs.cpp \
 LFSCObject.cpp \
 LFSCUtilProof.cpp \
 LFSCBoolProof.cpp \
 LFSCConvert.cpp \
 LFSCLraProof.cpp \
 LFSCPrinter.cpp \
 LFSCProof.cpp \
 TReturn.cpp \
 Util.cpp
# decision_engine_caching.cpp \
# decision_engine_mbtf.cpp

HEADERS = search_rules.h search_theorem_producer.h decision_engine.h decision_engine_dfs.h decision_engine_caching.h decision_engine_mbtf.h Util.h TReturn.h Object.h LFSCUtilProof.h LFSCProof.h LFSCPrinter.h LFSCObject.h LFSCLraProof.h LFSCConvert.h LFSCBoolProof.h

LIBRARY=libsearch.a

EXTRAFLAGS=$(DPLL_BASIC)

include ../../Makefile.local

=== debian/changelog ===
cvc3 (2.4.1-5.1ubuntu1) zesty; urgency=medium

  * Apply patch from debian to fix FTBFS with gcc 6.

 -- Bhavani Shankar <bhavi@ubuntu.com>  Sun, 22 Jan 2017 09:04:35 +0530

cvc3 (2.4.1-5ubuntu1) wily; urgency=medium

  * Rename library packages for g++5 ABI transition.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 03 Aug 2015 22:33:48 +0000

cvc3 (2.4.1-5) unstable; urgency=low

  * New maintainer. (Closes: #757192)
  * Fix clean target, resolving ppc64el FTBFS. (Closes: #756524)
  * Update standards version.
  * Fix dep5 copyright.
  * Remove Vcs-git and Vcs-browser (not available for CVC3).
  * Now lintian clean (with some overrides).

 -- Morgan Deters <mdeters@morgandeters.com>  Sat, 27 Sep 2014 12:21:27 -0400

cvc3 (2.4.1-4) unstable; urgency=low

  * Transfer package repo to Git.
  * Fix syntax error in debian/copyright.
  * Keep 50cvc3-el.el after remove. (Closes: #684351)
  * Use ln -sf when linking cvc3-el emacsen files. (Closes: #684026)
  * Remove build dep on gcj-native-helper. (Closes: #678183)

 -- Christopher L. Conway <cconway@cs.nyu.edu>  Sun, 12 Aug 2012 17:15:51 -0400

cvc3 (2.4.1-3) unstable; urgency=low

  * Create new package libcvc3-dev to replace libcvc3-5-dev and
    libcvc3-2-dev (Closes: #662198)
  * Add Replaces/Conflicts to libcvc3-5-jni for libcvc3-2-jni
    (Closes: #662200)
  * Leave .el files in site-lisp directory when installing cvc3-el
    to enable source lookup (Closes: #665319)
  * Remove cvc-mode autoload from site-start.d on cvc3-el removal
    (Closes: #668688)
  * Bring cvc3-el.emacsen-startup in line with Debian policy
    (Closes: #668685)

 -- Christopher L. Conway <cconway@cs.nyu.edu>  Mon, 16 Apr 2012 22:23:39 -0400

cvc3 (2.4.1-2) unstable; urgency=low

  * Upgrading to standards version 3.9.3
  * Fixing lintian errors
  * Fixing upstream tarball

 -- Christopher L. Conway <cconway@cs.nyu.edu>  Sat, 03 Mar 2012 18:00:13 -0500

cvc3 (2.4.1-1) unstable; urgency=low

  * New upstream release (Closes: #660244)
  * Updating to standards version 3.9.2
  * Switching to dpkg-source 3.0 (quilt) format
  * Changing default-jdk-builddep build dependency to default-jdk
  * Re-enabling libcvc3-jni on kfreebsd-amd64 (Closes: #576335)

 -- Christopher L. Conway <cconway@cs.nyu.edu>  Sat, 25 Feb 2012 13:54:15 -0500

cvc3 (2.2-13.1) unstable; urgency=low

   * NMU.  Change dependencies libgmp3-dev --> libgmp-dev.

 -- Steve M. Robbins <smr@debian.org>  Wed, 16 Mar 2011 21:43:31 -0500

cvc3 (2.2-13) unstable; urgency=low

  * Prevent Java tests from running on kfreebsd-amd64

 -- Christopher L. Conway <cconway@cs.nyu.edu>  Thu, 08 Apr 2010 13:46:21 -0400

cvc3 (2.2-12) unstable; urgency=low

  * Adding patch for MiniSat unsigned char bug (Closes: #575002)
  * Removing kfreebsd-amd64 from Architectures for libcvc3-2-jni (Workaround for
    #576335)

 -- Christopher L. Conway <cconway@cs.nyu.edu>  Tue, 06 Apr 2010 15:02:53 -0400

cvc3 (2.2-11) unstable; urgency=low

  * Patch: detect path to ldconfig for install

 -- Christopher L. Conway <cconway@cs.nyu.edu>  Tue, 16 Mar 2010 17:21:15 -0400

cvc3 (2.2-10) unstable; urgency=low

  * Upgrading to Debian Policy 3.8.4
  * Fixing problem with library path in 'make check'

 -- Christopher L. Conway <cconway@cs.nyu.edu>  Fri, 12 Mar 2010 17:48:43 -0500

cvc3 (2.2-9) unstable; urgency=low

  * Fixing bug in build environment for 'make check'

 -- Christopher L. Conway <cconway@cs.nyu.edu>  Tue, 26 Jan 2010 17:42:06 -0500

cvc3 (2.2-8) unstable; urgency=low

  * Adding regress0 as check target
  * Adding patch to create pkgconfig file

 -- Christopher L. Conway <cconway@cs.nyu.edu>  Tue, 26 Jan 2010 13:15:39 -0500

cvc3 (2.2-7) unstable; urgency=low

  * Adding cvc-mode to auto-mode-alist in cvc3-el

 -- Christopher L. Conway <cconway@cs.nyu.edu>  Wed, 06 Jan 2010 18:09:30 -0500

cvc3 (2.2-6) unstable; urgency=low

  * Moving cvc3 from Depends to Recommends for cvc3-el

 -- Christopher L. Conway <cconway@cs.nyu.edu>  Wed, 06 Jan 2010 17:45:43 -0500

cvc3 (2.2-5) unstable; urgency=low

  * Changing section for libcvc3-2 to 'libs'

 -- Christopher L. Conway <cconway@cs.nyu.edu>  Sun, 03 Jan 2010 13:37:27 -0500

cvc3 (2.2-4) unstable; urgency=low

  * Fixing lintian warnings for deps in emacs package and shlibs in JNI package

 -- Christopher L. Conway <cconway@cs.nyu.edu>  Thu, 31 Dec 2009 17:03:18 -0500

cvc3 (2.2-3) unstable; urgency=low

  * Fixing lintian warnings

 -- Christopher L. Conway <cconway@cs.nyu.edu>  Wed, 30 Dec 2009 18:08:59 -0500

cvc3 (2.2-2) unstable; urgency=low

  * Adding cvc3-el package

 -- Christopher L. Conway <cconway@cs.nyu.edu>  Thu, 10 Dec 2009 12:48:15 -0500

cvc3 (2.2-1) unstable; urgency=low

  * Initial release (Closes: bug#559245)

 -- Christopher L. Conway <cconway@cs.nyu.edu>  Mon, 07 Dec 2009 18:19:56 -0500

=== debian/control ===
Source: cvc3
Section: math
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Morgan Deters <mdeters@morgandeters.com>
Build-Depends: cdbs, debhelper (>= 7), autoconf, autotools-dev, bison, default-jdk, flex, libgmp-dev | libgmp3-dev, patchutils, python
Standards-Version: 3.9.5
Homepage: http://www.cs.nyu.edu/acsys/cvc3/

Package: cvc3
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Automatic theorem prover for SMT problems
 CVC3 is an automatic theorem prover for Satisfiability Modulo Theories
 (SMT) problems. It can be used to prove the validity (or, dually, the
 satisfiability) of first-order formulas in a large number of built-in
 logical theories and their combination.
 .
 CVC3 is the last offspring of a series of popular SMT provers, which
 originated at Stanford University with the SVC system. In particular,
 it builds on the code base of CVC Lite, its most recent
 predecessor. Its high level design follows that of the Sammy prover.
 .
 CVC3 works with a version of first-order logic with polymorphic types
 and has a wide variety of features including:
 .
  * several built-in base theories: rational and integer linear
    arithmetic, arrays, tuples, records, inductive data types, bit
    vectors, and equality over uninterpreted function symbols;
  * support for quantifiers;
  * an interactive text-based interface;
  * rich C, C++, and Java APIs for embedding in other systems;
  * proof and model generation abilities;
  * predicate subtyping;
  * essentially no limit on its use for research or commercial
    purposes (see license).
 .
 This package contains the CVC3 command line program.

Package: libcvc3-5v5
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libcvc3-5
Replaces: libcvc3-5
Description: Automatic theorem prover library for SMT problems
 CVC3 is an automatic theorem prover for Satisfiability Modulo Theories
 (SMT) problems. It can be used to prove the validity (or, dually, the
 satisfiability) of first-order formulas in a large number of built-in
 logical theories and their combination.
 .
 CVC3 is the last offspring of a series of popular SMT provers, which
 originated at Stanford University with the SVC system. In particular,
 it builds on the code base of CVC Lite, its most recent
 predecessor. Its high level design follows that of the Sammy prover.
 .
 CVC3 works with a version of first-order logic with polymorphic types
 and has a wide variety of features including:
 .
   * several built-in base theories: rational and integer linear
     arithmetic, arrays, tuples, records, inductive data types, bit
     vectors, and equality over uninterpreted function symbols;
   * support for quantifiers;
   * an interactive text-based interface;
   * rich C, C++, and Java APIs for embedding in other systems;
   * proof and model generation abilities;
   * predicate subtyping;
   * essentially no limit on its use for research or commercial
     purposes (see license).
 .
 This package contains the files necessary for running applications
 that use the CVC3 library.
    
Package: libcvc3-dev
Section: libdevel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libcvc3-5v5 (= ${binary:Version})
Replaces: libcvc3-5-dev, libcvc3-2-dev
Breaks: libcvc3-5-dev, libcvc3-2-dev
Description: Automatic theorem prover library for SMT problems (development files)
 CVC3 is an automatic theorem prover for Satisfiability Modulo Theories
 (SMT) problems. It can be used to prove the validity (or, dually, the
 satisfiability) of first-order formulas in a large number of built-in
 logical theories and their combination.
 .
 CVC3 is the last offspring of a series of popular SMT provers, which
 originated at Stanford University with the SVC system. In particular,
 it builds on the code base of CVC Lite, its most recent
 predecessor. Its high level design follows that of the Sammy prover.
 .
 CVC3 works with a version of first-order logic with polymorphic types
 and has a wide variety of features including:
 .
   * several built-in base theories: rational and integer linear
     arithmetic, arrays, tuples, records, inductive data types, bit
     vectors, and equality over uninterpreted function symbols;
   * support for quantifiers;
   * an interactive text-based interface;
   * rich C, C++, and Java APIs for embedding in other systems;
   * proof and model generation abilities;
   * predicate subtyping;
   * essentially no limit on its use for research or commercial
     purposes (see license).
 .
 This package contains the files necessary for building applications
 that use the CVC3 library.
    
Package: libcvc3-5-java
Section: java
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}, libcvc3-5-jni (>= ${source:Version})
Description: Java bindings for CVC3 (bytecode library)
 CVC3 is an automatic theorem prover for Satisfiability Modulo Theories
 (SMT) problems. It can be used to prove the validity (or, dually, the
 satisfiability) of first-order formulas in a large number of built-in
 logical theories and their combination.
 .
 CVC3 is the last offspring of a series of popular SMT provers, which
 originated at Stanford University with the SVC system. In particular,
 it builds on the code base of CVC Lite, its most recent
 predecessor. Its high level design follows that of the Sammy prover.
 .
 CVC3 works with a version of first-order logic with polymorphic types
 and has a wide variety of features including:
 .
  * several built-in base theories: rational and integer linear
    arithmetic, arrays, tuples, records, inductive data types, bit
    vectors, and equality over uninterpreted function symbols;
  * support for quantifiers;
  * an interactive text-based interface;
  * rich C, C++, and Java APIs for embedding in other systems;
  * proof and model generation abilities;
  * predicate subtyping;
  * essentially no limit on its use for research or commercial
    purposes (see license).
 .
 This package provides architecture-independent files of the Java
 bindings for CVC3

Package: libcvc3-5-jni
Section: java
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: libcvc3-2-jni
Breaks: libcvc3-2-jni
Description: Java bindings for CVC3 (native library)
 CVC3 is an automatic theorem prover for Satisfiability Modulo Theories
 (SMT) problems. It can be used to prove the validity (or, dually, the
 satisfiability) of first-order formulas in a large number of built-in
 logical theories and their combination.
 .
 CVC3 is the last offspring of a series of popular SMT provers, which
 originated at Stanford University with the SVC system. In particular,
 it builds on the code base of CVC Lite, its most recent
 predecessor. Its high level design follows that of the Sammy prover.
 .
 CVC3 works with a version of first-order logic with polymorphic types
 and has a wide variety of features including:
 .
  * several built-in base theories: rational and integer linear
    arithmetic, arrays, tuples, records, inductive data types, bit
    vectors, and equality over uninterpreted function symbols;
  * support for quantifiers;
  * an interactive text-based interface;
  * rich C, C++, and Java APIs for embedding in other systems;
  * proof and model generation abilities;
  * predicate subtyping;
  * essentially no limit on its use for research or commercial
    purposes (see license).
 .
 This package provides the native library needed for the Java bindings
 for CVC3

Package: cvc3-el
Architecture: all
Depends: emacs | emacsen, ${misc:Depends}
Recommends: cvc3
Enhances: cvc3
Description: Emacs mode for CVC3
 CVC3 is an automatic theorem prover for Satisfiability Modulo Theories
 (SMT) problems. It can be used to prove the validity (or, dually, the
 satisfiability) of first-order formulas in a large number of built-in
 logical theories and their combination.
 .
 CVC3 is the last offspring of a series of popular SMT provers, which
 originated at Stanford University with the SVC system. In particular,
 it builds on the code base of CVC Lite, its most recent
 predecessor. Its high level design follows that of the Sammy prover.
 .
 CVC3 works with a version of first-order logic with polymorphic types
 and has a wide variety of features including:
 .
  * several built-in base theories: rational and integer linear
    arithmetic, arrays, tuples, records, inductive data types, bit
    vectors, and equality over uninterpreted function symbols;
  * support for quantifiers;
  * an interactive text-based interface;
  * rich C, C++, and Java APIs for embedding in other systems;
  * proof and model generation abilities;
  * predicate subtyping;
  * essentially no limit on its use for research or commercial
    purposes (see license).
 .
 The package provides an Emacs major mode "cvc3-mode" with syntax
 highlighting for the CVC3 input language and running CVC3 as an
 inferior process.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_CXXFLAGS_MAINT_APPEND = -std=gnu++98

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/autotools.mk

# Basic build setup for CDBS
DEB_MAKE_CLEAN_TARGET := distclean TOP=$(CURDIR)
DEB_MAKE_INSTALL_TARGET := install prefix=$(DEB_DESTDIR)/usr
DEB_MAKE_CHECK_TARGET := regress0 LD_LIBRARY_PATH=$(CURDIR)/lib
DEB_CONFIGURE_EXTRA_FLAGS := --enable-dynamic --enable-java --with-java-home=/usr/lib/jvm/default-java --disable-zchaff

# Don't treat JNI .so's as shlibs
DEB_DH_MAKESHLIBS_ARGS_libcvc3-2-jni := --exclude=jni

# Have to run configure before distclean, or else make will die
cleanbuilddir/cvc3::
	rm -f java/Test_manifest
	dh_autotools-dev_updateconfig
	./configure --disable-zchaff
	dh_autotools-dev_restoreconfig

# cvc3-mode.el isn't copied by "make install", so copy it to the 
# staging directory by hand
install/cvc3-el::
	install -m 755 -d debian/cvc3-el/usr/share/emacs/site-lisp/cvc3-el
	install -m 644 emacs/cvc-mode.el debian/cvc3-el/usr/share/emacs/site-lisp/cvc3-el

# TODO(chris 2/10/2009): Trying to build the static library alongside
# the shared library is causing too many problems.
# # Build and install the static library as well as dynamic 
# build/libcvc3-1.5-dev::
# 	$(MAKE) STATIC=1
# 	$(MAKE) $(DEB_MAKE_INSTALL_TARGET) STATIC=1
# # Run make again so that the installed executables will be dynamic
# # (The CDBS default install targets will run *after* this)
# 	$(MAKE) STATIC=0

=== debian/watch ===
# Compulsory line, this is a version 3 file
version=3

opts=pgpsigurlmangle=s/$/.asc/ \
    http://www.cs.nyu.edu/acsys/cvc3/releases/current/cvc3-([\d\.]+)\.tar\.gz
